/*
 * Definition of the public parameters of the scheme, as defined in the specification.
 *
 * ==========================(LICENSE BEGIN)============================
 *
 * Copyright (c) 2023  Squirrels Project
 *
 * Permission is hereby granted, free of charge, to any person obtaining
 * a copy of this software and associated documentation files (the
 * "Software"), to deal in the Software without restriction, including
 * without limitation the rights to use, copy, modify, merge, publish,
 * distribute, sublicense, and/or sell copies of the Software, and to
 * permit persons to whom the Software is furnished to do so, subject to
 * the following conditions:
 *
 * The above copyright notice and this permission notice shall be
 * included in all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
 * IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
 * CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
 * TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
 * SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 *
 * ===========================(LICENSE END)=============================
 *
 * @author   Guilhem Niot <guilhem.niot@gniot.fr>
 */

#include "api.h"

#define SQUIRRELS_K 320

#if SQUIRRELS_LEVEL == 1
#define SQUIRRELS_D 1034
#define SQUIRRELS_Q 4096
#define SQUIRRELS_GSNORM_MIN 27.898036819196015
#define SQUIRRELS_GSNORM_MAX 31.491273142076107
#define SQUIRRELS_GS0NORM_MIN 27.9
#define SQUIRRELS_GS0NORM_MAX 30.1
#define SQUIRRELS_SIGMA 40.24667610603854
#define SQUIRRELS_SIGMIN 1.2780263257208286
#define SQUIRRELS_BETA_SQUARE 2026590

#define SQUIRRELS_NBPRIMES 165
#define SQUIRRELS_LOG_DET_ON_DIM 3.383648132136603

#define SQUIRRELS_SIG_BYTESIZE 1019
#define SQUIRRELS_SIG_RATE 4
#endif
#if SQUIRRELS_LEVEL == 2
#define SQUIRRELS_D 1164
#define SQUIRRELS_Q 4096
#define SQUIRRELS_GSNORM_MIN 28.998036819196017
#define SQUIRRELS_GSNORM_MAX 32.52421298740167
#define SQUIRRELS_GS0NORM_MIN 29
#define SQUIRRELS_GS0NORM_MAX 31
#define SQUIRRELS_SIGMA 41.64307184026483
#define SQUIRRELS_SIGMIN 1.2803713915043962
#define SQUIRRELS_BETA_SQUARE 2442439

#define SQUIRRELS_NBPRIMES 188
#define SQUIRRELS_LOG_DET_ON_DIM 3.416887402501479

#define SQUIRRELS_SIG_BYTESIZE 1147
#define SQUIRRELS_SIG_RATE 5
#endif
#if SQUIRRELS_LEVEL == 3
#define SQUIRRELS_D 1556
#define SQUIRRELS_Q 4096
#define SQUIRRELS_GSNORM_MIN 33.798036819196014
#define SQUIRRELS_GSNORM_MAX 37.94718416834481
#define SQUIRRELS_GS0NORM_MIN 33.8
#define SQUIRRELS_GS0NORM_MAX 36.2
#define SQUIRRELS_SIGMA 48.955191460637074
#define SQUIRRELS_SIGMIN 1.2900875923614654
#define SQUIRRELS_BETA_SQUARE 4512242

#define SQUIRRELS_NBPRIMES 262
#define SQUIRRELS_LOG_DET_ON_DIM 3.57120554551052

#define SQUIRRELS_SIG_BYTESIZE 1554
#define SQUIRRELS_SIG_RATE 5
#endif
#if SQUIRRELS_LEVEL == 4
#define SQUIRRELS_D 1718
#define SQUIRRELS_Q 4096
#define SQUIRRELS_GSNORM_MIN 27.798036819196014
#define SQUIRRELS_GSNORM_MAX 32.47328023599738
#define SQUIRRELS_GS0NORM_MIN 27.8
#define SQUIRRELS_GS0NORM_MAX 30.2
#define SQUIRRELS_SIGMA 41.956477667696724
#define SQUIRRELS_SIGMIN 1.2920307823164412
#define SQUIRRELS_BETA_SQUARE 3659372

#define SQUIRRELS_NBPRIMES 275
#define SQUIRRELS_LOG_DET_ON_DIM 3.3897981925509293

#define SQUIRRELS_SIG_BYTESIZE 1676
#define SQUIRRELS_SIG_RATE 5
#endif
#if SQUIRRELS_LEVEL == 5
#define SQUIRRELS_D 2056
#define SQUIRRELS_Q 4096
#define SQUIRRELS_GSNORM_MIN 30.698036819196012
#define SQUIRRELS_GSNORM_MAX 35.78439165303195
#define SQUIRRELS_GS0NORM_MIN 30.7
#define SQUIRRELS_GS0NORM_MAX 33.3
#define SQUIRRELS_SIGMA 46.460893820222594
#define SQUIRRELS_SIGMIN 1.2983563971328835
#define SQUIRRELS_BETA_SQUARE 5370115

#define SQUIRRELS_NBPRIMES 339
#define SQUIRRELS_LOG_DET_ON_DIM 3.488127515563797

#define SQUIRRELS_SIG_BYTESIZE 2025
#define SQUIRRELS_SIG_RATE 5
#endif
